# Merge Test
Use this file to exercise the GitHub portions of the OpenHW Group workflow.

Parts of the [OpenHW Group workflow](https://github.com/openhwgroup/core-v-docs/blob/master/verif/Common/OpenHWGroup_WorkFlow.pdf)
are modeled after Vincent Driessen's [git branching model](https://nvie.com/posts/a-successful-git-branching-model/).  When
you first register as a member of OpenHW, you can use this file to safely test whether you have the appropriate GitHub contributor priviledges for this repo.   Try this:
* Fork the repository: https://help.github.com/en/github/getting-started-with-github/fork-a-repo
* Clone repository: `git clone https://github.com/[your_github_username]/core-v-verif`
* Create your feature branch: `git checkout -b my-new-feature`
* Commit your changes: `git commit -m 'Add some feature' -s`
* Push feature branch: `git push origin my-new-feature`
* Submit a pull request

When all of that works, you are ready to make contributions to the OpenHW Group CORE-V projects.

If you are new to git, or unfamiliar with using branches and pull-requests, have a look at our [Git Cheat Sheet](https://github.com/openhwgroup/core-v-verif/blob/master/GitCheats.txt).

## Make your changes below this line.
Extra marks for creativity and wit.


### Madcat
```
            /^v^\
  /^v^\                  /^v^\
         /^v^\
     ____          ____
    |oooo|        |oooo|
    |oooo| .----. |oooo|
    |Oooo|/\O||O/\|oooO|
    `----' / \/ \ `----'
    ,/ |#|/\/||\/\|#| \,
   /  \|#|| |/\| ||#|/  \
  / \_/|_|| |/\| ||_|\_/ \
 |_\/    o\=----=/o    \/_|
 <_>      |=\__/=|      <_>
 <_>      |------|      <_>
 | |   ___|======|___   | |
//\\  / |O|======|O| \  //\\
|  |  | |O+------+O| |  |  |
|\/|  \_+/        \+_/  |\/|
\__/  _|||        |||_  \__/
      | ||        || |
     [==|]        [|==]
     [===]        [===]
      >_<          >_<
     || ||        || ||
     || ||        || ||
     || ||        || ||    -- Jay Thaler 
   __|\_/|__    __|\_/|__     -- David Poulin
  /___n_n___\  /___n_n___\
  ```

### Gecko
```
                                                         ## ##                  
                                                       ##### *                  
                                                        ###/                    
                                                     #####                      
                             *#########        ########.                        
                           ########################                             
                       ###############################                          
                     #####&@&&&&&&&&%################(((/                       
                                      %%%##########((((((((                     
            (                            %######((((((((((((                    
           (                              ###((((((((((((((((.                  
          (                               ((((   (((((((((((((                  
         (                         *#   ((((      (((((((((((((                 
        ((                       ###((((           (((((((((((((                
        ((                      *  ((               ((((((((((((                
        /(                                    (((((  (((((((((((                
        /((                                (( (((((((((((((((((((((((((         
         /((                            ,((((((((((((((((//((((((((((((         
          //(                               (.(    ((((((////////((((((  ((     
          ,////                         (((   ((    (((((//////     /////////   
            /////                                   ((((/////       /   /*      
             ///////                             (((((/////        //    //     
               ////////.                     /((((((/////                       
                  **///////////,     *((((((((((//////                          
                     ****//////////((((((((////////                             
                          /*******************                               

```
{signal: [
  {name: 'clk',           wave: 'p.....'},
  {name: 'mergetest_req', wave: '01....'},
  {name: 'mergetest_ack', wave: '0.X...'},
]}
```
